/* File operations */
/* Access a previously closed file problem */
/* Context sensitive example */
/* Unions */

#include "stdio.h"

struct sample {
	union {
		FILE *fp;
	} un1;
};

FILE *file_open(const char *fname, const char *mode)
{
	return fopen(fname,mode);
}

int file_getc(FILE *ptr)
{
	return fgetc(ptr);	
}

void file_close(FILE *ptr)
{
        if(ptr) fclose(ptr);
}

int main()
{
	struct sample sct;
	int c;

	sct.un1.fp = file_open("file1.txt","r");
	
	if(sct.un1.fp) c = file_getc(sct.un1.fp);	/* OK */

	if(sct.un1.fp) file_close(sct.un1.fp);
	
	if(sct.un1.fp) c = file_getc(sct.un1.fp);	/* DANGER */

	return 1;
}
