/* File operations */
/* Access a previously closed file problem */
/* Context sensitive example */
/* Typedef */

#include "stdio.h"

struct sample {
	FILE *fp;
};

typedef struct sample new_sample;

FILE *file_open(const char *fname, const char *mode)
{
	return fopen(fname,mode);
}

int file_getc(FILE *ptr)
{
	return fgetc(ptr);	
}

void file_close(FILE *ptr)
{
        if(ptr) fclose(ptr);
}

int main()
{
	new_sample sct;
	int c;

	sct.fp = file_open("file1.txt","r");
	
	if(sct.fp) c = file_getc(sct.fp);	/* OK */

	if(sct.fp) file_close(sct.fp);
	
	if(sct.fp) c = file_getc(sct.fp);	/* DANGER */

	return 1;
}
