/* File operations */
/* Access a file in a different way from which has been opened problem */
/* Context sensitive example */
/* Different functions */

#include "stdio.h"

FILE *file_open(const char *fname, const char *mode)
{
	return fopen(fname,mode);
}

int file_getc(FILE *ptr)
{
	return fgetc(ptr);	
}

int file_putc(FILE *ptr, int val)
{
	return fputc(val,ptr); 	
}

void file_close(FILE *ptr)
{
        if(ptr) fclose(ptr);
}

int main()
{
        FILE *fp;
	int c1;
        int c2 = (int) 'd';

	fp = file_open("file1.txt","r");
	
	if(fp) c1 = file_getc(fp);	/* OK */

	if(fp) file_putc(fp,c2);	/* DANGER */

	if(fp) file_close(fp);
	
	return 1;
}
