/* File operations */
/* Access a file in a different way from which has been opened problem */
/* Context sensitive example */
/* Global variables */

#include "stdio.h"

FILE *fp;

void file_open(const char *fname, const char *mode)
{
        fp = fopen(fname,mode);
}

int file_getc()
{
        return fgetc(fp);
}

int file_putc(int val)
{
	return fputc(val,fp);
}

void file_close()
{
        if(fp) fclose(fp);
}

int main()
{
	int c1;
	int c2 = (int) 'd';

	file_open("file1.txt","r");

	if(fp) c1 = file_getc();	/* OK */

        if(fp) file_putc(c2);		/* DANGER */

	if(fp) fclose(fp);
	
	return 1;
}
