/* File operations */
/* Double file closing problem */
/* Context sensitive example */
/* Function pointers */

#include "stdio.h"

FILE *file_open(const char *fname, const char *mode)
{
        return fopen(fname,mode);
}

void file_close(FILE *ptr)
{
        if(ptr) fclose(ptr);
}

int main()
{
        FILE *fp;

	FILE* (*file_open_ptr)(const char*,const char*) = 0;
	void (*file_close_ptr)(FILE*) = 0;

	file_open_ptr = &file_open;
	file_close_ptr = &file_close;

	fp = (*file_open_ptr)("file1.txt","r");

	(*file_close_ptr)(fp);	/* OK */
	
	(*file_close_ptr)(fp);	/* DANGER */

	return 1;
}
