/* File operations */
/* Opening file without closing it problem */
/* Context sensitive example */
/* Unions */

#include "stdio.h"

struct sample {
	union {
		FILE *fp1;
	} un1;
	union {
		FILE *fp2;
	} un2;
};

FILE *file_open(const char *fname, const char *mode)
{
        return fopen(fname,mode);
}
void file_close(FILE *fp)
{
	if(fp) fclose(fp);
}

int main()
{
	struct sample sct;

	sct.un1.fp1 = file_open("file1.txt","r");	
	sct.un2.fp2 = file_open("file2.txt","r");

	file_close(sct.un1.fp1);	/* OK */
	
	/* DANGER - sct.un2.fp2 no close */

	return 1;
}
