/* File operations */
/* Accesing file without opening it problem */
/* Context sensitive example */
/* Unions */

#include "stdio.h"

struct sample {
	union {
		FILE *fp1;
	} un1;
	union {
		FILE *fp2;
	} un2;
};

FILE *file_open(const char *fname, const char *mode)
{
        return fopen(fname,mode);
}

int file_getc(FILE *fp)
{
        return fgetc(fp);
}

int main()
{
	struct sample sct;
	int c;

	sct.un1.fp1 = file_open("file1.txt","r");	

	if(sct.un1.fp1) c = file_getc(sct.un1.fp1);	/* OK */

	c = file_getc(sct.un2.fp2);			/* DANGER */

	if(sct.un1.fp1) fclose(sct.un1.fp1);

	return 1;
}
