/* File operations */
/* No checking success of file I/O functions problem */
/* Context sensitive example */
/* Function pointers */

#include "stdio.h"

FILE *file_open(const char *fname, const char *mode)
{
	return fopen(fname,mode);
}

int file_getc(FILE *fp)
{
	return fgetc(fp);	
}

int main()
{
        FILE *fp;
	int c;

	FILE* (*file_open_ptr)(const char*,const char *) = 0;
	int (*file_getc_ptr)(FILE*) = 0;

	file_open_ptr = &file_open;
	file_getc_ptr = &file_getc;

	fp = (*file_open_ptr)("file1.txt","r");
	
	c = (*file_getc_ptr)(fp);		/* DANGER */

	if(fp) (*file_getc_ptr)(fp);		/* OK */

	if(fp) fclose(fp);
	
	return 1;
}
