/* File operations */
/* No checking success of file I/O functions problem */
/* Context sensitive example */
/* Unions */

#include "stdio.h"

struct sample {
	union {
		FILE *fp;
	} un1;
};

FILE *file_open(const char *fname, const char *mode)
{
	return fopen(fname,mode);
}

int file_getc(FILE *fp)
{
	return fgetc(fp);	
}

int main()
{
        struct sample sct;
	int c;

	sct.un1.fp = file_open("file1.txt","r");
	
	c = file_getc(sct.un1.fp);		/* DANGER */

	if(sct.un1.fp) file_getc(sct.un1.fp);	/* OK */

	if(sct.un1.fp) fclose(sct.un1.fp);
	
	return 1;
}
