/* Format string problem */
/* Context sensitive example */
/* Function pointers */

#include "stdio.h"

void fill_name(char *name)
{
        printf("Enter your name:");
        scanf("%s",name);
}

void fill_real_name(char *real_name)
{
	sprintf(real_name,"George");
}

void print_name(char *name)
{
	printf(name);
}

int main()
{
	char user_name[256];
	char real_name[256];
	char danger_name[256]="%s%s%s";

	void (*fill_name_ptr)(char*) = 0;	
	void (*print_name_ptr)(char*) = 0;
	
	fill_name_ptr = &fill_name;
	fill_name(user_name);
	fill_name_ptr = &fill_real_name;
	fill_real_name(real_name);

	print_name_ptr = &print_name;
	(*print_name_ptr)(user_name); 	/* DANGER */
	(*print_name_ptr)(real_name);	/* OK */	
	(*print_name_ptr)(danger_name);	/* DANGER */

	return 1;
}
