/* Dynamic memory management problems */
/* Initialization error */
/* Context sensitive example */
/* Function pointers */

#include "malloc.h"

void calc_sum(int *C, int *A, int i)
{
	C[i] = C[i] + A[i];
}

int main()
{
	int a[5] = {1,2,3,4,5};
        int *c;
	int *d;

	void (*calc_sum_ptr)(int*,int*,int) = 0;

	calc_sum_ptr = &calc_sum;

	c = malloc(5*sizeof(int));	
	d = calloc(5,sizeof(int));

	(*calc_sum_ptr)(c,a,2);	/* DANGER */

	(*calc_sum_ptr)(d,a,2);	/* OK */

	free(c);
	free(d);
	
	return 1;
}
