/* Dynamic memory management problems */
/* Memory allocation without free error */
/* Context sensitive example */
/* Unions */

#include "malloc.h"

struct sample {
	union {
		int *c;
	} unc;
	union {
		int *d;
	} und;
};

int *free_pointer(int *ptr)
{
	free(ptr);
	return ptr;
}

int main()
{
	struct sample sct;

	sct.unc.c = malloc(5*sizeof(int));	
	sct.und.d = malloc(5*sizeof(int));

	sct.und.d = free_pointer(sct.und.d);	/* OK */
	
	/* DANGER - sct.unc.c no free */

	return 1;
}
