/* Race conditions */
/* Deadlock, no threads */
/* Context sensitive example */
/* Function pointers */

/* lock / unlock functions */
static int use_system=0;
void lock()
{
        do {
                if(use_system == 0) {
                        use_system = 1;
                }
        }while(use_system == 1);
}

void unlock()
{
        use_system = 0;
}
/* end lock / unlock functions */

void lock_system()
{
	lock();
}

void unlock_system()
{
	unlock();
}

int main()
{
	void (*lock_system_ptr)() = 0;
	void (*unlock_system_ptr)() = 0;

	lock_system_ptr = &lock_system;
	unlock_system_ptr = &unlock_system;

	(*lock_system_ptr)();
        (*unlock_system_ptr)();

        (*lock_system_ptr)();
        (*lock_system_ptr)();         /* DANGER */
        (*unlock_system_ptr)();

        return 1;
}
