/* Race conditions */
/* Deadlock with threads */
/* Alias analysis */
/* Casting assignments */

#include "stdio.h"
#include "pthread.h"

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

void print1()
{
        pthread_mutex_lock(&mutex);
        printf("George\n");
        pthread_mutex_unlock(&mutex);
}

void print2()
{
        pthread_mutex_lock(&mutex);
        printf("John\n");
}

int main()
{
	int x = 10;
	int *x1;
	void *x2;
	int x3;
	pthread_t thr1, thr2, thr3;

        pthread_create(&thr1,0,(void*)&print1,0);
        pthread_create(&thr2,0,(void*)&print2,0);
        pthread_create(&thr3,0,(void*)&print1,0);

	x1 = (int*) x;
	x2 = (void*) x1;
	x3 = (int) x2;

	pthread_join(thr1,0);

	if(x3 > 20) {
		pthread_join(thr2,0);	/* OK */
	}else{
		pthread_join(thr2,0);	/* DANGER */
	}

	pthread_join(thr3,0);

	return 1;
}
