/* Race conditions */
/* Deadlock with threads */
/* Context sensitive example */
/* Typedef */

#include "stdio.h"
#include "pthread.h"

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
struct sample {
	pthread_t thr1;
	pthread_t thr2;
	pthread_t thr3;
};

typedef struct sample new_sample;

new_sample sct;

void print1()
{
        pthread_mutex_lock(&mutex);
        printf("George\n");
        pthread_mutex_unlock(&mutex);
}

void print2()
{
        pthread_mutex_lock(&mutex);
        printf("John\n");
}

void call_thread1()
{
	pthread_join(sct.thr1,0);
}

void call_thread2()
{
	pthread_join(sct.thr2,0);
}

void call_thread3()
{
	pthread_join(sct.thr3,0);
}

int main()
{
        pthread_create(&sct.thr1,0,(void*)&print1,0);
        pthread_create(&sct.thr2,0,(void*)&print2,0);
        pthread_create(&sct.thr3,0,(void*)&print1,0);

	call_thread1();
	call_thread2();	/* DANGER */
	call_thread3();        

	return 1;
}
