/* Race conditions */
/* Deadlock with threads */
/* Flow sensitive example */
/* Typical for loop and if-else statement  */

#include "stdio.h"
#include "pthread.h"

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

void print1()
{
        pthread_mutex_lock(&mutex);
        printf("George\n");
        pthread_mutex_unlock(&mutex);
}

void print2()
{
        pthread_mutex_lock(&mutex);
        printf("John\n");
}

int main()
{
	int i;
	pthread_t thr1, thr2, thr3;

        pthread_create(&thr1,0,(void*)&print1,0);
        pthread_create(&thr2,0,(void*)&print2,0);
        pthread_create(&thr3,0,(void*)&print1,0);

	pthread_join(thr1,0);

	for(i = 0; i < 20; i++) {
		if(i >= 20) {
                	pthread_join(thr2,0);   /* OK */
		}else{
                        pthread_join(thr2,0);   /* DANGER */
		}
	}

	pthread_join(thr3,0);

	return 1;
}
