/* File operations */
/* Access a previously closed file problem */
/* Context sensitive example */
/* Function pointers */

#include "stdio.h"

FILE *file_open(const char *fname, const char *mode)
{
	return fopen(fname,mode);
}

int file_getc(FILE *ptr)
{
	return fgetc(ptr);	
}

void file_close(FILE *ptr)
{
        if(ptr) fclose(ptr);
}

int main()
{
        FILE *fp;
	int c;

	FILE* (*file_open_ptr)(const char*,const char*) = 0;
	int (*file_getc_ptr)(FILE*) = 0;
	void (*file_close_ptr)(FILE*) = 0;

	file_open_ptr = &file_open;
	file_getc_ptr = &file_getc;
	file_close_ptr = &file_close;

	fp = (*file_open_ptr)("file1.txt","r");
	
	if(fp) c = (*file_getc_ptr)(fp);	/* OK */

	if(fp) (*file_close_ptr)(fp);
	
	if(fp) c = (*file_getc_ptr)(fp);	/* DANGER */

	return 1;
}
