/* File operations */
/* Double file closing problem */
/* Context sensitive example */
/* Unions */

#include "stdio.h"

struct sample {
	union {
		FILE *fp;
	} un1;
};

FILE *file_open(const char *fname, const char *mode)
{
        return fopen(fname,mode);
}

void file_close(FILE *ptr)
{
        if(ptr) fclose(ptr);
}

int main()
{
        struct sample sct;

	sct.un1.fp = file_open("file1.txt","r");

	file_close(sct.un1.fp);	/* OK */
	
	file_close(sct.un1.fp);	/* DANGER */

	return 1;
}
