/* File operations */
/* Opening file without closing it problem */
/* Context sensitive example */
/* Function pointers */

#include "stdio.h"

FILE *file_open(const char *fname, const char *mode)
{
        return fopen(fname,mode);
}
void file_close(FILE *fp)
{
	if(fp) fclose(fp);
}

int main()
{
        FILE *fp1, *fp2;

	FILE* (*file_open_ptr)(const char*,const char*) = 0;
	void (*file_close_ptr)(FILE *) = 0;

	file_open_ptr = &file_open;
	file_close_ptr = &file_close;

	fp1 = (*file_open_ptr)("file1.txt","r");	
	fp2 = (*file_open_ptr)("file2.txt","r");

	file_close(fp1);	/* OK */
	
	/* DANGER - fp2 no close */

	return 1;
}
