/* File operations */
/* Accesing file without opening it problem */
/* Context sensitive example */
/* Function pointers */

#include "stdio.h"

FILE *file_open(const char *fname, const char *mode)
{
        return fopen(fname,mode);
}

int file_getc(FILE *fp)
{
        return fgetc(fp);
}

int main()
{
        FILE *fp1, *fp2;
	int c;

	FILE* (*file_open_ptr)(const char*,const char*) = 0;
	int (*file_getc_ptr)(FILE*) = 0;

	file_open_ptr = &file_open;
	file_getc_ptr = &file_getc;

	fp1 = (*file_open_ptr)("file1.txt","r");	

	if(fp1) c = (*file_getc_ptr)(fp1);	/* OK */

	c = (*file_getc_ptr)(fp2);		/* DANGER */

	if(fp1) fclose(fp1);

	return 1;
}
