/* Dynamic memory management problems */
/* Referencing freed memory error */
/* Context sensitive example */
/* Function pointers */

#include "malloc.h"

int *free_pointer(int *ptr)
{
	free(ptr);
	return ptr;
}

void assign(int *C, int i, int value)
{
	C[i] = value;
}

int main()
{
        int *c;

	int* (*free_pointer_ptr)(int*) = 0;
	void (*assign_ptr)(int*,int,int) = 0;

	free_pointer_ptr = &free_pointer;
	assign_ptr = &assign;

	c = malloc(5*sizeof(int));	

	c = (*free_pointer_ptr)(c);
	
	(*assign_ptr)(c,2,10);	/* DANGER */

	return 1;
}
