/* Race conditions */
/* Time of check, time of use (TOCTOU) */
/* Context sensitive example */
/* Function pointers */

#include "stdio.h"
#include "sys/stat.h"

void lstat_file(char *path, struct stat *st)
{
        lstat(path,st);
}

int remove_file(char *path)
{
        return remove(path);
}

int main()
{
	struct stat info;

	void (*lstat_file_ptr)(char*,struct stat*) = 0;
	int (*remove_file_ptr)(char*) = 0;

	lstat_file_ptr = &lstat_file;
	remove_file_ptr = &remove_file;

        (*lstat_file_ptr)("file1.link",&info);
        if(info.st_uid > 10) {
                printf("Accepted\n");
                (*remove_file_ptr)("file1.link");      /* DANGER */
        }	

	return 1;
}
